
#  Translate.py  Copyright (c) Kari Laitinen

#  http://www.naturalprogramming.com

#  2006-05-06  File created.
#  2022-12-27  Converted to Python 3.

import sys   # needed when command line parameters are used

class BilingualTranslation :

   def __init__( self, given_first_word,
                       given_second_word ) :

      self.first_word   =  given_first_word
      self.second_word  =  given_second_word


   def translate( self, given_word ) :

      translation_was_successful  =  False

      if  given_word  ==  self.first_word  :

         print( "\n \"%s\" translates to \"%s\"" %   \
                ( given_word, self.second_word ), end="" )

         translation_was_successful  =  True

      if  given_word  ==  self.second_word  :

         print( "\n \"%s\" translates to \"%s\"" %   \
                ( given_word, self.first_word ), end="" )

         translation_was_successful  =  True

      return  translation_was_successful


class TrilingualTranslation ( BilingualTranslation ) :

   def __init__( self, given_first_word,
                       given_second_word,
                       given_third_word ) :

      self.first_word   =  given_first_word
      self.second_word  =  given_second_word
      self.third_word   =  given_third_word


   def translate( self, given_word ) :

      translation_was_successful  =  False

      if  given_word  ==  self.first_word  :

         print( "\n \"%s\" translates to \"%s\" and \"%s\""  %  \
                ( given_word, self.second_word, self.third_word ), end="" )

         translation_was_successful  =  True


      if  given_word  ==  self.second_word  :

         print( "\n \"%s\" translates to \"%s\" and \"%s\""  %  \
                ( given_word, self.first_word, self.third_word ), end="" )

         translation_was_successful  =  True


      if  given_word  ==  self.third_word  :

         print( "\n \"%s\" translates to \"%s\" and \"%s\""  %  \
                ( given_word, self.first_word, self.second_word ), end="" )

         translation_was_successful  =  True


      return  translation_was_successful




#  The main program begins.

list_of_translations  =  []

list_of_translations.append( BilingualTranslation( "week", "semana" ) )
list_of_translations.append( TrilingualTranslation( "street",
                                                     "calle", "rue" ) )
list_of_translations.append( BilingualTranslation( "eat", "comer" ) )
list_of_translations.append( TrilingualTranslation( "woman",
                                                     "mujer", "femme" ) )
list_of_translations.append( TrilingualTranslation( "man",
                                                     "hombre", "homme" ) )
list_of_translations.append( BilingualTranslation( "sleep", "dormir" ) )

command_line_parameters  =  sys.argv[ 1 : ]

if len( command_line_parameters )  ==  1 :

   translation_index  =  0

   while  translation_index  <  len( list_of_translations )  :

      list_of_translations[ translation_index ]. \
                       translate( command_line_parameters[ 0 ] )

      translation_index  +=  1


   print( "\n" )

else :

   print( "\n Give a word on command line.\n" )


